/***************************************************************************
                          kblticker.h  -  description
                             -------------------
    begin                : Mon Feb 16 10:46:56 MSK 2004
    copyright            : (C) 2004 by Konstantin Grusha
    email                : zoi@project7.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBLTICKER_H
#define KBLTICKER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stream.h>

#include <qhttp.h>
#include <qurl.h>
#include <qregexp.h>
#include <qwidget.h>
#include <qtimer.h>
#include <qprocess.h>

#include <kapp.h>
#include <kuniqueapp.h>
#include <kuniqueapplication.h>
#include <klocale.h>
#include <kmessagebox.h>

#include "kbltickertrayicon.h"
#include "kbltickerconfig.h"
#include "kbltickerballoon.h"
#include "kbltickerconfigdlg.h"

/** KBLTicker is the base class of the project */
class KBLTicker : public KUniqueApplication
{
  Q_OBJECT
public:
	/** constructor */
	KBLTicker();
	/** destructor */
	~KBLTicker();

private: // Private attributes
	/** System tray icon is the main widget. */
	KBLTickerTrayIcon * m_trayicon;
	/** Loads our config */
	KBLTickerConfig m_kbconf;
	/** This object will ping BlogLines. */
	QHttp bl_pinger;
	/** Send browser to this url. */
	QString url_updates;

private slots: // Private slots
	/** Pings BlogLines.com with your data. */
	void slotPingBlogLines();
	/** Called upon arrival of new data. */
	void slotPingDone(bool error);
	/** Prepare to launch konqueror upon left-click on the icon. */
	void slotGetBrowser(QString *url);
	/** Brings up konqueror with the url returned from the search. */
	void slotLaunchBrowser();
	/** Display the preferences dialog. */
	void slotPreferences();

signals: // Signals
	/** Shout 'Gimme a flag' out loud. */
	void raiseMeFlag(int new_entries);
	/** Shout 'I have an URL as well!' */
	void haveUpdatedUrl(QString *url);
	/** Drops the flag. */
	void dropMeFlag();
	/** If anyone will ask, just ping them. */
	void pingIt();
};

#endif
