/***************************************************************************
                          kbltickerconfig.cpp  -  description
                             -------------------
    begin                : ??? ??? 16 2004
    copyright            : (C) 2004 by Konstantin Grusha
    email                : zoi@project7.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kdeversion.h>
#include <klocale.h>
#include <kglobal.h>
#if KDE_VERSION_MAJOR >= 3
  #include <kstandarddirs.h>
  #include <kapplication.h>
#else
  #include <kstddirs.h>
  #include <kapp.h>
#endif
#include <kglobalsettings.h>

#include <qnamespace.h>
#include <qpainter.h>
#include <qimage.h>

#include "kbltickerconfig.h"

#define CHECK_PERIOD_ENTRY "check_period"
#define EMAIL_ENTRY "email"
#define NOTIFY_BELLS_ENTRY "notify_bells"
#define NOTIFY_WHISTLES_ENTRY "notify_whistles"
#define NOTIFY_SOUND_ON_ENTRY "notify_sound_on"
#define THRESHOLD_ENTRY "threshold"
#define NOTIFY_MESSAGE_ON_ENTRY "notify_message_on"

KBLTickerConfig::KBLTickerConfig(){
	KStandardDirs *dir = KGlobal::dirs();

	m_check_period = 30;
	m_email = "joe@random.hacker";
	m_notify_bells = dir->findResource("sound", "kblticker_bells.wav");
	m_notify_whistles = dir->findResource("sound", "kblticker_whistles.wav");
	m_notify_sound_on = true;
	m_threshold = 10;
	m_notify_message_on = true;
}

KBLTickerConfig::~KBLTickerConfig(){
}

/** Load configuration from the application KConfig object */
void KBLTickerConfig::load(KConfig *config){
	config->setGroup(OPTIONS_SECTION);

	m_check_period = config->readNumEntry(CHECK_PERIOD_ENTRY, m_check_period);
	m_email = config->readEntry(EMAIL_ENTRY, m_email);
	m_notify_bells = config->readPathEntry(NOTIFY_BELLS_ENTRY, m_notify_bells);
	m_notify_whistles = config->readPathEntry(NOTIFY_WHISTLES_ENTRY, m_notify_whistles);
	m_notify_sound_on = config->readBoolEntry(NOTIFY_SOUND_ON_ENTRY, m_notify_sound_on);
	m_threshold = config->readNumEntry(THRESHOLD_ENTRY, m_threshold);
	m_notify_message_on = config->readBoolEntry(NOTIFY_MESSAGE_ON_ENTRY, m_notify_message_on);

	cout << "Checking BlogLines every " << m_check_period << " minutes" << endl;
	cout << "Your email is " << m_email << endl;
	cout << "Sound notification is " << (m_notify_sound_on ? "on" : "off") << endl;
	if (m_notify_sound_on)
		cout << "Bells: " << m_notify_bells << endl << "Whistles: " << m_notify_whistles << endl;
	cout << "Bell/Whistle threshold is " << m_threshold << endl;
	cout << "Popup notification is " << (m_notify_message_on ? "on" : "off") << endl;
}

/** Save configuration to the application KConfig object */
void KBLTickerConfig::save(KConfig *config){
	config->setGroup(OPTIONS_SECTION);
	config->writeEntry(CHECK_PERIOD_ENTRY, m_check_period);
	config->writeEntry(EMAIL_ENTRY, m_email);
	config->writeEntry(THRESHOLD_ENTRY, m_threshold);
	config->writeEntry(NOTIFY_BELLS_ENTRY, m_notify_bells);
	config->writeEntry(NOTIFY_WHISTLES_ENTRY, m_notify_whistles);
	config->writeEntry(NOTIFY_SOUND_ON_ENTRY, m_notify_sound_on);
	config->writeEntry(NOTIFY_MESSAGE_ON_ENTRY, m_notify_message_on);
	
	cout << "Saving configuration..." << endl;
}
