/***************************************************************************
                          kbltickerconfig.h  -  description
                             -------------------
    begin                : ??? ??? 16 2004
    copyright            : (C) 2004 by Konstantin Grusha
    email                : zoi@project7.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBLTICKERCONFIG_H
#define KBLTICKERCONFIG_H

#include <stream.h>

#include <qptrvector.h>
#include <qvaluevector.h>
#include <qstring.h>

#include <kconfig.h>
#include <kglobalaccel.h>

#define OPTIONS_SECTION "Options"

/**Processes configuration data of KBLTicker.
  *@author Konstantin Grusha
  */

class KBLTickerConfig {
private: // Private attributes
	/** Ping BlogLines every m_check_period minutes */
	int m_check_period;
	/** Sound notifications differs when the number of new entries is above m_threshold. */
	int m_threshold;
	/** Bells ring when the number of new entries is below m_threshold. */
	QString m_notify_bells;
	/** Whistles occur, when the number of new entries is above m_threshold. */
	QString m_notify_whistles;
	/** User login on BlogLines */
	QString m_email;
	/** Do we play a sound if there's news? */
	bool m_notify_sound_on;
	/** Do we display a message when there's news? */
	bool m_notify_message_on;
public:
	KBLTickerConfig();
	~KBLTickerConfig();
	/** Load configuration from the application KConfig object */
	void load(KConfig *config);
	/** Save configuration to the application KConfig object */
	void save(KConfig *config);
	/** No descriptions */
	int check_period() { return m_check_period; };
	int threshold() { return m_threshold; };
	QString notify_bells() { return m_notify_bells; };
	QString notify_whistles() { return m_notify_whistles; };
	bool notify_sound_on() { return m_notify_sound_on; };
	bool notify_message_on() { return m_notify_message_on; };
	QString email() { return m_email; };
	void set_check_period(int n_check_period) { m_check_period=n_check_period; };
	void set_threshold(int n_threshold) { m_threshold=n_threshold; };
	void set_notify_bells(QString n_notify_bells) { m_notify_bells=n_notify_bells; };
	void set_notify_whistles(QString n_notify_whistles) { m_notify_whistles=n_notify_whistles; };
	void set_notify_sound_on(bool n_notify_sound_on) { m_notify_sound_on=n_notify_sound_on; };
	void set_notify_message_on(bool n_notify_message_on) { m_notify_message_on=n_notify_message_on; };
	void set_email(QString n_email) { m_email=n_email; };
};

#endif
