/***************************************************************************
                          kbltickerconfigdlg  -  description
                             -------------------
    begin                :   21 2004
    copyright            : (C) 2004 by Konstantin Grusha
    email                : zoi@project7.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef KBLTICKERCONFIGDLG_H
#define KBLTICKERCONFIGDLG_H

#include <qwidget.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qcombobox.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qspinbox.h>

#include <kpushbutton.h>
#include <kdialogbase.h>
#include <kkeydialog.h>
#include <klineedit.h>

#include "kbltickerconfig.h"

/**
Configuration dialog for KBLTicker

@author Konstantin Grusha
*/
class KBLTickerConfigDlg : public KDialogBase
{
	Q_OBJECT
public:
	KBLTickerConfigDlg(KBLTickerConfig *kbconf, QWidget *parent = 0, const char *name = 0);
	~KBLTickerConfigDlg();

private:
	KBLTickerConfig *m_kbconf;
	QCheckBox *chkToggleSound;
	QCheckBox *chkToggleMessage;
	QSpinBox *spnCheckPeriod;
	QSpinBox *spnThreshold;

	KLineEdit *edtEmail;
	KLineEdit *edtBells;
	KLineEdit *edtWhistles;

	KPushButton *btnBells;
	KPushButton *btnWhistles;

	void setupGeneralPage();
	void showConfig();
	void saveConfig();

protected:
	virtual void slotOk();

private slots:
	void slotSelectBells();
	void slotSelectWhistles();
    void slotToggleBellsWhistles();
};

#endif
