/***************************************************************************
                          kbltickertrayicon.h  -  description
                             -------------------
    begin                : ??? ??? 16 2004
    copyright            : (C) 2004 by Konstantin Grusha
    email                : zoi@project7.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBLTICKERTRAYICON_H
#define KBLTICKERTRAYICON_H

#include <stream.h>

#include <qtooltip.h>

#include <kaudioplayer.h>
#include <ksystemtray.h>
#include "kbltickerconfig.h"
#include "kbltickerballoon.h"

/**The system tray icon. Shows the current ticker status and lets the user configure the ticker.
  *@author Konstantin Grusha
  */

class KBLTickerTrayIcon : public KSystemTray  {
  Q_OBJECT
public: 
	KBLTickerTrayIcon(KBLTickerConfig *conf);
	~KBLTickerTrayIcon();
	/** Pull up a flag if there's something new, or pull it down, if there's not. */
	void updateTrayIcon(int status);
	/** Returns the current state of the flag. */
	bool flagRaised() { return flag_raised; };
	void updateTrayTooltip(QString text) { QToolTip::remove(this); QToolTip::add(this, text); };
public slots: // Public slots
	/** No descriptions */
	void slotAbout();
private slots: // Private slots
	/** Handle incoming entries */
	void slotRaiseFlag(int new_entries);
	/** Handle incoming entries */
	void slotDropFlag();
	/** Remove the balloon */
	void slotRemoveBalloon();
private: // Private attributes
	/**  */
	KBLTickerConfig * m_kbconf;
	/** The balloon notifies us of new stuff. */
	KBLTickerBalloon * m_balloon;
	bool flag_raised;
protected: // Protected methods
	/** No descriptions */
	void mouseReleaseEvent(QMouseEvent *event);
signals:
	/** No descriptions */
	void clicked();
	void preferencesSelected();
};

#endif
